--
--
--
puck = sprite:new()
--This class is the base class for all graphical objects.
--
--
puck.graphic = players.puck
puck.xSpeed = 0;
puck.ySpeed = 0;

puck.oX = 8
puck.oY = 8
puck.stopped = false

puck.anis = lightWorld:newAnimationGrid(puck.graphic,100,100)
--player.anis:setNormalMap(players.tempNormal)
puck.g = puck.anis:newGrid(17, 17)


puck.anis:addAnimation('moving',puck.g('1-2',1), 0.0167)
puck.anis:addAnimation('stopped',puck.g('1-2',2), 0.0167)
puck.hasAni = true
puck.currentAni = "moving"
puck.anis:setAnimation(puck.currentAni)
puck.anis.ix = 0
puck.stopTime = 0;
puck.anis.iy = 0
function puck:update(dt)
       local oldX = self.x;
      self.x = math.rd(self.x + math.rd(self.xSpeed))
      self.y = math.rd(self.y + math.rd(self.ySpeed))
     
      self.ySpeed = self.ySpeed + .3
      self.xSpeed = self.xSpeed * .98
      if self.ySpeed > 12 then
            self.ySpeed = 12
      end
      if self.xSpeed > 12 then
            self.xSpeed = 12
      end
      if self.xSpeed < -12 then
            self.xSpeed = -12
      end
      
     if math.abs(self.xSpeed) <.3 then
         self.xSpeed = 0
      end
      if math.abs(self.ySpeed) <.3 then
         self.ySpeed = 0
      end
     
      while cWithLevel(self.x+8, self.y+17) do 
         self.y = self.y - 1
      end
   
 
      if cWithLevel(self.x+8, self.y+19) then
         if self.ySpeed>3 then
            self.y = self.y - 4
            self.ySpeed = self.ySpeed * -.5
            self.xSpeed = self.xSpeed * .9
         else
            self.ySpeed = 0
         end
      end   
      
      
      while cWithLevel(self.x+8, self.y) do 
         self.y = self.y + 1
      end
   
 
      if cWithLevel(self.x+8, self.y-2) then
            self.y = self.y + 4
            self.ySpeed = self.ySpeed * -.8
      end   
      
      
      while cWithLevel(self.x, self.y+8) do 
         self.x = self.x + 1
      end
      while cWithLevel(self.x+17, self.y+8) do 
         self.x = self.x - 1
      end
      if cWithLevel(self.x-2, self.y+8) then
         self.x = self.x  + 4
         self.xSpeed = self.xSpeed * -.6        
      end   
      
      if cWithLevel(self.x+19, self.y+8) then
         self.x = self.x  - 4
         self.xSpeed = self.xSpeed * -.6        
      end   
      self.rot = self.rot+((oldX - self.x)/12)
      
      
      if self.ySpeed == 0 and self.xSpeed == 0 then
         self.stopTime = self.stopTime + 1
         if self.stopTime>10 then
            self.stopped = true
         self.currentAni = "stopped"
         end
         
      end
      self.anis:setAnimation(self.currentAni)
      
end